/*
Dane wejsciowe (wlasnosci werteksu):
gl_Vertex - pooenie (we wsp. modelu), vec4
gl_Color - kolor, vec4
gl_Normal - normalna, vec3
gl_MultiTexCoord0 - wsprzdne teksturowania (indeks 0), vec4

Parametry:
gl_ModelViewProjectionMatrix = mul(gl_ProjectionMatrix,gl_ModelViewMatrix), mat4
gl_NormalMatrix, mat3 (transponowane elementy z gl_ModelViewMatrix przyciete do mat3)

Dane wyjsciowe (wlasnosci werteksu):
gl_Position - pozycja (obowizkowe!), vec4
gl_FrontColor - kolor, vec4
*/

bool KopiujKolorWerteksu = true;
bool PokazNormalne = false;

vec4 Ce  = vec4(0,0,0,0);
vec4 Ca  = vec4(1,1,1,1);
vec4 Cd  = vec4(1,1,1,1);

vec4 Wa = vec4(0.3,0.3,0.3,1);
vec4 Wd = vec4(0.6,0.6,0.6,1);

vec3 PozycjaZrodlaSwiatla = vec3(1,1,1);

//te wszystkie parametry powinny byc uniform

void main(void)
{
    // przeksztacenia model-widok
    gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;   

    //gl_FrontColor = gl_Color;

    //model Phonga    
    vec3 R=(gl_ModelViewMatrix*gl_Vertex).xyz;
    vec3 L=normalize(PozycjaZrodlaSwiatla-R);
    vec3 N=normalize(gl_NormalMatrix*gl_Normal);
    float dotLN=clamp(dot(L,N),0,1);	

    if(PokazNormalne)
    {
        gl_FrontColor=vec4(abs(gl_Normal),1);
        //gl_FrontColor=vec4(N,1);
        return;
    }

    if(KopiujKolorWerteksu)
    {
        Ca=gl_Color;
        Cd=gl_Color;
    }

    gl_FrontColor=clamp(Ce,0,1);
    gl_FrontColor+=clamp(Wa*Ca,0,1);
    gl_FrontColor+=clamp(Wd*Cd*dotLN,0,1);
    gl_FrontColor=clamp(gl_FrontColor,0,1);
}
